diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index 00d241f232..4927bfebfa 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -1552,7 +1552,6 @@ ExecOnConflictUpdate(ModifyTableState *mtstate,
 	ExecCheckHeapTupleVisible(estate, &tuple, buffer);
 
 	/* Store target's existing tuple in the state's dedicated slot */
-	ExecSetSlotDescriptor(mtstate->mt_existing, relation->rd_att);
 	ExecStoreTuple(&tuple, mtstate->mt_existing, buffer, false);
 
 	/*
diff --git a/src/backend/optimizer/prep/preptlist.c b/src/backend/optimizer/prep/preptlist.c
index 3ff8d86853..4a864b2340 100644
--- a/src/backend/optimizer/prep/preptlist.c
+++ b/src/backend/optimizer/prep/preptlist.c
@@ -142,7 +142,7 @@ preprocess_targetlist(PlannerInfo *root)
 					action->targetList = expand_targetlist(action->targetList,
 														   action->commandType,
 														   result_relation,
-														   RelationGetDescr(target_relation));
+														   target_relation);
 					break;
 				case CMD_DELETE:
 					break;
